import torch
from torch_geometric.transforms import RemoveIsolatedNodes
from torch_geometric.data import Data


def test_remove_isolated_nodes():
    assert RemoveIsolatedNodes().__repr__() == 'RemoveIsolatedNodes()'

    edge_index = torch.tensor([[0, 2, 1, 0], [2, 0, 1, 0]])
    edge_attr = torch.tensor([1, 2, 3, 4])
    x = torch.tensor([[1], [2], [3]])
    data = Data(edge_index=edge_index, edge_attr=edge_attr, x=x)
    data = RemoveIsolatedNodes()(data)
    assert len(data) == 3
    assert data.edge_index.tolist() == [[0, 1, 0], [1, 0, 0]]
    assert data.edge_attr.tolist() == [1, 2, 4]
    assert data.x.tolist() == [[1], [3]]
